﻿using System;
using System.IO;

namespace com.swivelsecure.pinsafe {
    public class Debug {
	    private const string DEFAULT_LOG_FILE_NAME = @"\PINsafeOWAFilter.log";
        private const string DEFAULT_LOG_FOLDER = @"C:\Users\Public\Documents";
		private const string DEFAULT_LOG_FOLDER_W2003 = @"C:\Documents and Settings\All Users\Documents";

        private static Debug instance = null;

        public static void Initialize(bool enable = false, string location = "") {
            if (!enable) {
                instance = null;
                return;
            }
            if (instance == null) {
                instance = new Debug();
            }
            instance.InitInstance(string.IsNullOrEmpty(location) ? GetDefaultLogFile() : location);
        }

		private static string GetDefaultLogFile() {
			if (Directory.Exists(DEFAULT_LOG_FOLDER)) {
				return DEFAULT_LOG_FOLDER + DEFAULT_LOG_FILE_NAME;
			}
			if (Directory.Exists(DEFAULT_LOG_FOLDER_W2003)) {
				return DEFAULT_LOG_FOLDER_W2003 + DEFAULT_LOG_FILE_NAME;
			}
			return "C:" + DEFAULT_LOG_FILE_NAME;
		}

        private string logFile;

        private void InitInstance(string location) {
            logFile = location;
        }

        public static void WriteLine(string message) {
            if (instance == null) return;
            instance.WriteLineInstance(message);
        }

        private void WriteLineInstance(string message) {

            using (StreamWriter writer = new StreamWriter(logFile, true)) {
                string timestamp = DateTime.Now.ToString("s");
                writer.WriteLine(timestamp + "\t" + message);
            }
        }
    }
}
