﻿using System;
using System.Globalization;
using System.Web.UI;
using com.swivelsecure.pinsafe;

namespace PINsafeLogin.auth {
    public partial class CheckUser : Page {
        protected void Page_Load(object sender, EventArgs e) {
            string username = Request["username"];
            PINsafeClient client = PINsafeClient.GetWebInstance();
            PINsafeSettings settings = client.Settings;

            if (settings.AllowNonPINsafeUsers) {
                if (string.IsNullOrEmpty(username)) {
                    Debug.WriteLine("CheckUser.aspx: No username entered");
                    Response.Output.Write("");
                } else {
                    PINsafeRequest request = new PINsafeRequest();
                    string exists = settings.EnableMultipleUsernames ? client.UserExistsByAttribute(request, username) : client.UserExists(request, username).ToString(CultureInfo.InvariantCulture);
                    Debug.WriteLine(String.Format("CheckUser.aspx: {0} returned {1} for user {2}", settings.EnableMultipleUsernames ? "UserExistsByAttribute" : "UserExists", exists, username));
                    Response.Output.Write(exists);
                }
            } else {
                Debug.WriteLine("CheckUser.aspx: Non-PINsafe users not allowed");
                // User must exist.
                Response.Output.Write(settings.EnableMultipleUsernames ? "default" : "true");
            }
            Response.End();
        }
    }
}
