﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Net;
using System.Text;
using System.Web.UI;
using com.swivelsecure.pinsafe;

namespace PINsafeLogin.auth {
    public partial class SCImage : Page {
        protected void Page_Load(object sender, EventArgs e) {
            // Get the ID of the image to retrieve.
            string username = Request["username"];
            PINsafeClient client = PINsafeClient.GetWebInstance();
            if (String.IsNullOrEmpty(username)) {
                // No username: check for connectivity.
                if (!client.CheckServers()) {
                    Response.StatusCode = (int) HttpStatusCode.NotFound;
                    Debug.WriteLine("SCImage.aspx: No PINsafe server found");
                } else {
                    Debug.WriteLine("SCImage.aspx: No username - showing blank image");
                    Response.ContentType = "image/gif";
                    StringBuilder disposition = new StringBuilder("inline; filename=turing.gif");
                    Response.AddHeader("Content-Disposition", disposition.ToString());
                    Image img = PINsafeClient.BlankImage;
                    if (img != null) {
                        img.Save(Response.OutputStream, ImageFormat.Gif);
                    }
                }
            } else {
                string type = Request["type"];
                int statusCode;
                PINsafeRequest request = new PINsafeRequest();
                Image img = (type != null && "message".Equals(type)) ? client.GetMessage(request, null, username, out statusCode) : client.GetImage(request, null, username, out statusCode);
                if (statusCode != (int) HttpStatusCode.OK) {
                    Response.StatusCode = statusCode;
                    Debug.WriteLine(String.Format("SCImage.aspx: PINsafe returned status code {0} for user {1}", statusCode, username));
                } else {
                    Response.ContentType = "image/gif";
                    StringBuilder disposition = new StringBuilder("inline; filename=turing.gif");
                    Response.AddHeader("Content-Disposition", disposition.ToString());
                    if (img != null) {
                        img.Save(Response.OutputStream, ImageFormat.Gif);
                    }
                }
            }
        }
    }
}