﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Net;
using System.Text;
using System.Web.UI;
using com.swivelsecure.pinsafe;

namespace PINsafeLogin.auth {
    public partial class SCPinpad : Page {
        protected void Page_Load(object sender, EventArgs e) {
            // Get the ID of the image to retrieve.
            string username = Request["username"];
			string padno = Request["padno"];
			PINsafeClient client = PINsafeClient.GetWebInstance();
            if (String.IsNullOrEmpty(username)) {
                // No username: check for connectivity.
                if (!client.CheckServers()) {
                    Response.StatusCode = (int) HttpStatusCode.NotFound;
                    Debug.WriteLine("SCPinpad.aspx: No PINsafe server found");
                } else {
					Debug.WriteLine("SCPinpad.aspx: No username - showing blank image");
                    Response.ContentType = "image/jpg";
                    StringBuilder disposition = new StringBuilder("inline; filename=pinpad.jpg");
                    Response.AddHeader("Content-Disposition", disposition.ToString());
                    Image img = PINsafeClient.BlankPinpadImage;
                    if (img != null) {
                        img.Save(Response.OutputStream, ImageFormat.Jpeg);
                    }
                }
            } else {
                int statusCode;
                PINsafeRequest request = new PINsafeRequest();
                Image img = client.GetPinpadImage(request, username, padno, out statusCode);
                if (statusCode != (int) HttpStatusCode.OK) {
                    Response.StatusCode = statusCode;
					Debug.WriteLine(String.Format("SCPinpad.aspx: PINsafe returned status code {0} for user {1}, padno {2}", statusCode, username, padno));
                } else {
                    Response.ContentType = "image/jpg";
                    StringBuilder disposition = new StringBuilder("inline; filename=pinpad.jpg");
                    Response.AddHeader("Content-Disposition", disposition.ToString());
                    if (img != null) {
                        img.Save(Response.OutputStream, ImageFormat.Jpeg);
                    }
                }
            }
        }
    }
}