var xmlHttp;

var XMLHttpFactories = [
	function () { return new window.XMLHttpRequest(); },
	function () { return new ActiveXObject("Msxml3.XMLHTTP"); },
	function () { return new ActiveXObject("Msxml2.XMLHTTP"); },
	function () { return new ActiveXObject("Microsoft.XMLHTTP"); }
];

function createXMLHttpRequest() {
    var xmlhttp = false;
    for (var i = 0; i < XMLHttpFactories.length; i++) {
        try {
            xmlhttp = XMLHttpFactories[i]();
        }
        catch (e) {
            continue;
        }
        break;
    }
    return xmlhttp;
}

function GetUsername() {
    var userField = document.getElementById("username");
    if (!userField || !userField.value) {
        return null;
    }
    var username = userField.value;
    return username;
}

function setUserExists(exists) {
    var rowOtc = document.getElementById("OTCRow");
    var rowTuring = document.getElementById("TuringRow");
    var spanButton = document.getElementById("TuringButton");
    var spanMBtn = document.getElementById("MessageButton");
    var cpTable = document.getElementById("tblChangePin");
    var chkUserExists = document.getElementById("userExists");
    if (exists) {
        if (rowOtc) {
            rowOtc.style.display = "";
        }
        if (spanButton && document.getElementById("showTuring").checked) {
            spanButton.style.display = "";
        }
        if (spanMBtn && document.getElementById("showMessage").checked) {
            spanMBtn.style.display = "";
        }
        if (cpTable && document.getElementById("showChangePin").checked) {
            cpTable.style.display = "";
        }
        if (document.getElementById("autoShow").checked) {
            ShowTuring();
        }
        if (document.getElementById("showPinpad").checked) {
            ShowPinpad();
        }
        chkUserExists.checked = true;
    } else {
        if (rowOtc) {
            rowOtc.style.display = "none";
        }
        if (spanButton) {
            spanButton.style.display = "none";
        }
        if (spanMBtn) {
            spanMBtn.style.display = "none";
        }
        if (cpTable) {
            cpTable.style.display = "none";
        }
        if (rowTuring) {
            rowTuring.style.display = "none";
        }
        chkUserExists.checked = false;
    }
}

function onUserExists() {
    if (xmlHttp.readyState != 4) return;
    var exists = false;
    if (xmlHttp.status == 200) {
        var resultText = xmlHttp.responseText;
        exists = (resultText.toLowerCase() == "true");
    }
    setUserExists(exists);
}

function CheckUser() {
    var chkPINsafeOff = document.getElementById("noPINsafe");
    var chkAllowUnknown = document.getElementById("allowUnknown");
    if (!chkPINsafeOff.checked) {
        if (!chkAllowUnknown.checked) {
            setUserExists(true);
        } else {
            var username = GetUsername();
            if (username && username != "") {
                var pinsafeUrl = "./CheckUser.aspx?username=" + username + "&random=" + Math.floor(Math.random() * 100000);
                xmlHttp = createXMLHttpRequest();
                xmlHttp.onreadystatechange = onUserExists;
                xmlHttp.open("GET", pinsafeUrl, true);
                xmlHttp.send(null);
            } else {
                setUserExists(false);
            }
        }
    }
}

function setPINsafeSettings(required, allowUnknown, showTuring, showMessage, autoShow, showPinpad, showChangePin) {
    var rowOtc = document.getElementById("OTCRow");
    var rowTuring = document.getElementById("TuringRow");
    var rowPinpad = document.getElementById("PinpadRow");
    var chkPINsafeOff = document.getElementById("noPINsafe");
    var chkAllowUnknown = document.getElementById("allowUnknown");
    var chkShowTuring = document.getElementById("showTuring");
    var chkShowMessage = document.getElementById("showMessage");
    var chkAutoShow = document.getElementById("autoShow");
    var chkShowPinpad = document.getElementById("showPinpad");
    var chkShowChangePin = document.getElementById("showChangePin");
    if (required) {
        chkPINsafeOff.checked = false;
        chkAllowUnknown.checked = allowUnknown;
        chkShowTuring.checked = showTuring && !showPinpad;
        chkShowMessage.checked = showMessage;
        chkAutoShow.checked = showTuring && autoShow && !showPinpad;
        chkShowPinpad.checked = showPinpad;
        chkShowChangePin.checked = showChangePin;
        CheckUser();
    } else {
        if (rowOtc) {
            rowOtc.style.display = "none";
        }
        if (rowTuring) {
            rowTuring.style.display = "none";
        }
        if (rowPinpad) {
            rowPinpad.style.display = "none";
        }
        chkPINsafeOff.checked = true;
        chkAllowUnknown.checked = true;
        chkShowTuring.checked = false;
        chkShowMessage.checked = false;
        chkAutoShow.checked = false;
        chkShowPinpad.checked = false;
        chkShowChangePin.checked = false;
    }
}

function onPINsafeRequired() {
    if (xmlHttp.readyState != 4) return;
    var required = false;
    var showTuring = false;
    var showMessage = false;
    var autoShow = false;
    var allowUnknown = false;
    var showPinpad = false;
    var showChangePin = false;
    if (xmlHttp.status == 200) {
        var resultText = xmlHttp.responseText;
        if (resultText.length >= 7) {
            required = (resultText.charAt(0) == "1");
            allowUnknown = (resultText.charAt(1) == "1");
            showTuring = (resultText.charAt(2) == "1");
            showMessage = (resultText.charAt(3) == "1");
            autoShow = (resultText.charAt(4) == "1");
            showPinpad = (resultText.charAt(5) == "1");
            showChangePin = (resultText.charAt(6) == "1");
        }
    }
    setPINsafeSettings(required, allowUnknown, showTuring, showMessage, autoShow, showPinpad, showChangePin);
}

function CheckClient() {
    var chkPINsafeOff = document.getElementById("noPINsafe");
    chkPINsafeOff.checked = true;
    var pinsafeUrl = "./CheckClient.aspx";
    xmlHttp = createXMLHttpRequest();
    xmlHttp.onreadystatechange = onPINsafeRequired;
    xmlHttp.open("GET", pinsafeUrl, true);
    xmlHttp.send(null);
}

function ShowTuring() {
    var username = GetUsername();
    if (username && username != "") {
        var thisRow = document.getElementById("TuringRow");
        thisRow.style.display = "";
        var turing = document.getElementById("TuringImage");
        turing.src = "./SCImage.aspx?username=" + username + "&random=" + Math.floor(Math.random() * 100000);
    }
}

function ShowMessage() {
    var username = GetUsername();
    if (username && username != "") {
        var thisRow = document.getElementById("TuringRow");
        thisRow.style.display = "";
        var turing = document.getElementById("TuringImage");
        turing.src = "./SCImage.aspx?type=message&username=" + username + "&random=" + Math.floor(Math.random() * 100000);
    }
}

function ShowPinpad() {
    var username = GetUsername();
	if (username && username != "") {
	    var thisRow = document.getElementById("PinpadRow");
	    thisRow.style.display = "";
	    var sessionId = Math.floor(Math.random() * 10000);
		for (var idx = 0; idx < 10; idx++) {
		    var img = document.getElementById("imgPinpad" + idx);
			if (img) {
				img.src = "./SCPinpad.aspx?username=" + username + "&padno=" + sessionId + ":" + idx;
			}
		}
	}
}

function addDigit(digit) {
    var textField = document.getElementById("otc");
    if (textField) {
        textField.value = textField.value + digit;
    }
    return false;
}
